/************************************************************************************
*
* Copyright (c) 2003 The University of Texas
* All Rights Reserved.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* The GNU Public License is available in the file LICENSE, or you
* can write to the Free Software Foundation, Inc., 59 Temple Place -
* Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
* World Wide Web at http://www.fsf.org.
*
* IN NO EVENT SHALL THE UNIVERSITY OF TEXAS BE LIABLE TO ANY PARTY 
* FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES 
* ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
* THE UNIVERSITY OF TEXAS HAS BEEN ADVISED OF THE POSSIBILITY OF 
* SUCH DAMAGE.
*
* THE UNIVERSITY OF TEXAS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
* PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
* TEXAS HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
* ENHANCEMENTS, OR MODIFICATIONS.
*
* Programmers:  Mayank Gupta <mayank@mail.utexas.edu ; mayank42@hotmail.com>
* Advisor:      Prof. Brian L. Evans
* Version:      0.1
*
************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include "ROT_header.h"

extern short image[Blkrow][Blkcol];
/************************************************************************************
 * Edge(int r,int c,int *numpixels) 
 * This function the image block with the following filter
 * filter numerator = {-2, -8, -2}
 *	   				  {-8, 52, -8}
 *	   				  {-2, -8, -2}
 * filter denominator, D = 12
 *
 * Variance threshold parameter to remove false edges that may be changed:
 * t = 15; 
 ************************************************************************************/
void FilterDetectEdge(int r,int c,int *numpixels){

int i,j,k1,k2,cntr,m;
short filter[3][3] = {{-2, -8, -2}, {-8, 52, -8}, {-2, -8, -2}};
short D = 12;
short t = 15;
short temp_img[2][Blkcol-2];

for (i = 0; i < c-2; i++) {
	temp_img[0][i] = 0;}


//#pragma MUST_ITERATE(1,89); 
for (i = 0,cntr=0; i < r-1; i++){
//#pragma MUST_ITERATE(1,88); 
	for (j = 0; j < c-2; j++){
//	#pragma MUST_ITERATE(3,3); 
		for ( k1 = 0; k1 < 3; k1++){
//		#pragma MUST_ITERATE(3,3); 
			for ( k2 = 0; k2 < 3; k2++){
				temp_img[cntr][j] += ((filter[k1][k2]) * (image[(i + k1)][( j + k2)]) / D) ;}}}
	cntr++;
	if (cntr == 2) cntr = 0;
//	#pragma MUST_ITERATE(1,88); 
		for (m = 0 ; m < c-2 ; m ++){
			if ((temp_img[cntr][m] - image[i][m+1]) < t)	// threshold
				image[i][m+1] = 0;
			else
				{image[i][m+1] = 155;(*numpixels)++;} //255 to view edge
				temp_img[cntr][m] = 0; }
			
}


return;
}
